; File Name   :	d:\hobby3\elektronik\mikrorechner-akustik-set\MAS.bin
; Base Address:	0000h Range: 0000h - 0400h Loaded length: 0400h

; 02.02.2020 vpohlers Das ist (fast) der orig. Quellcode, nur mit 
; erweiterten Kommentaren und die 4 separaten Teile mit phase getrennt

		cpu	z80

;------------------------------------------------------------------------------
; Warnsignale
;------------------------------------------------------------------------------
 
		org	0
		phase 0

		di
ANF:		ld	a, (8000h)	; Tastenabfrage
		and	3Fh 
		cp	0
		jr	z, ANF		; keine Taste
		cp	20h 
		jr	z, VWA		; Taste 6 - Vorwarnung
		cp	10h
		jr	z, ATL		; Taste 5 - Atomalarm
		cp	8
		jr	z, CHA		; Taste 4 - Chemischer Alarm
		cp	4
		jr	z, KATA		; Taste 3 - Katastrophenalarm
		cp	2
		jr	z, FEUA		; Taste 2 - Feueralarm
VWA:		ld	ix, VWANF	; Taste 1 - Vor-/Entwarnung
		jr	ANSCHW
ATL:		ld	ix, ATLANF
		jr	ANSCHW
CHA:		ld	ix, CHANF
		jr	ANSCHW
KATA:		ld	ix, KATANF
		jr	ANSCHW
FEUA:		ld	ix, FEUANF
; Anschwellen
ANSCHW:		exx
		ld	l, (ix+0)	; Tonanzahlregister TAR laden
		exx
WDH:		ld	e, 40h		; Periodenzhler PZ
		ld	d, 0FFh		; Pegelregister PR
		ld	h, 1		; Primrer Stufenzhler PSTZ
		ld	c, 0FFh		; Primres Tonhhenregister PTHR, ca 50 Hz
AN1:		ld	l, h		; STZ mit PSTZ laden
AN2:		xor	a		; High-Ausgabe
		ld	b, c		; THR mit PTHR laden
		out	(c), d
S4:		djnz	$		; bis THR=0
		out	(c), b
		ld	b, c
S5:		djnz	$		; bis THR=0
		dec 	l		; dec STZ 
		jr	nz, AN2		; bis STZ=0
		dec 	c		; dec PTHR
		ld	a, c		; 
		cp	29h		; 800 Hz ?
		jr	z, TON
		dec	e		; PZ=0 ?
		jr	nz, AN1
		sla	h		; PSTZ*2
		ld	e, 40h		; PZ laden
		jr	AN1
; Tonausgabe
TON:		xor	a		; High-Ausgabe
		ld	d, 0FFh		; Pegelregister PR
		ld	c, (ix+1)	; Tonlnge laden Periodenzhler PZ3
PZ2:		ld	e, 4		; Periodenzhler PZ2 = 4
PZ1:		ld	h, 0C8h		; TLR Periodenzhler PZ1 = 200
TS3:		ld	b, 29h		; THR 800 Hz laden
		out	(c), d		; High Ausgabe
TS4:		djnz	$		; bis THR=0
		ld	b, 29h		; THR 800 Hz laden
		out	(c), b		; Low Ausgabe
TS5:		djnz	$		; bis THR=0
		dec	h		; dec TLR PZ1
		jr	nz, VERZ1
		dec	e		; dec TLR PZ2
		jr	nz, VERZ2	; Schleife fr Tonlnge
		dec	c		; dec TLR PZ3
		jr	nz, PZ2
; Abschwellen	
		ld	e, 40h		; Periodenzhler PZ
		ld	d, 0FFh		; Pegelregister PR
		ld	h, 8		; Primrer Stufenzhler PSTZ
		ld	c, 29h		; Primres Tonhhenregister PTHR 800 Hz
AB1:		ld	l, h		; STZ mit PSTZ laden
AB2:		xor	a		; Low laden
		ld	b, c		; THR mit PTHR laden
		out	(c), d
AS4:		djnz	$		; bis THR=0
		out	(c), b
		ld	b, c
AS5:		djnz	$		; bis THR=0
		dec 	l		; Periodendauer DEC
		jr	nz, AB2
		inc	c		; inc PTHR
		jr	z, PAUSE0	; bis ca 50Hz (0FFh+1)
		dec	e		; PZ=0 ?
		jr	nz, AB1
		srl	h		; PSTZ/2
		ld	e, 40h		; PZ laden
		jr	AB1
; Verzgerung 2		
VERZ2:		nop
		nop
		jr	PZ1
; Verzgerung 1
VERZ1:		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jr	TS3
; Pause
PAUSE0:		exx
		dec	l
		exx
		jp	z, ANF
PAUSE:		ld 	c, (ix+2)	; Pausendauer laden PZ3
PPZ2:		ld	e, 4		; Periodenzhler PZ2 = 4
PPZ1:		ld	h, 0C8h		; TLR Periodenzhler PZ1 = 200
PS3:		ld	b, 29h		; THR 800 Hz laden
		out	(c), b		; Pausenschleife
PS4:		djnz	$
		ld	b, 29h
		out	(c), b
PS5:		djnz	$		; Pausenschleife
		dec	h		; dec TLR PZ1
		jr	nz, PS3		; Pausenschleife
		dec	e		; dec TLR PZ2
		jr	nz, PPZ1	; Pausenschleife
		dec	c		; dec TLR PZ3
		jr	nz, PPZ2	; Pausenschleife
;
		jp	WDH

; je 3 Byte
;	Tonanzahl
;	Tonlnge
; 	Pausendauer
; ges. Zeit = Anzahl x (3x Anschwellen+Ton+3s abschwellen+Pause)
VWANF:		db    1			; Vorwarnung 1x, 177s Ton, 0s Pause
		db 0B1h			
		db    0

ATLANF:		db  12h			; Atomalarm 18x, 2s Ton, 2s Pause
		db    2
		db    2

CHANF:		db    8			; Chemischer Alarm 8x: 7s Ton, 12s Pause
		db    7
		db  0Ch

KATANF:		db    5			; Katastrophenalarm 5x: 27s Ton, 7s Pause
		db  1Bh
		db    7

FEUANF:		db    3			; Feueralarm 3x: 12s Ton, 2s Pause
		db  0Ch
		db    2
		
		dephase

;------------------------------------------------------------------------------
; Volkslieder 
;------------------------------------------------------------------------------
 
		org 100h
		phase 0
		
LS0:		di
		ld	ix, LAA		; Liedanfangsadresse LAA laden
LS1:		inc	ix		; LAA erhhen
LANF:		ld	a, (8000h)	; Tastenabfrage
		and	3Fh
		cp	0
		jr	z, LANF		; solange keine Taste gedrckt
		cp	1
		jr	nz, INT		; Taste 2..6 Liedfolge LAA
		ld	ix, LAAS	; Taste 1 - LAAS (Die Gedanken sind frei)
;		
INT:		ld	iy, TLA		; Tonleiteradresse TLA laden
		ld	a, (ix+0)	; Akku mit Wert aus Liedtabelle laden
		cp	0FFh		; Ende der Liedfolge erreicht
		jr	z, LS0
		and	0F0h
		cp	0E0h		; Ende eines Liedes erreicht
		jr	z, LS1
		cp	0F0h		; Pause?
		jr	z, PAUDA
;Ton		
		srl	a		; Akku 4x rechts schieben
		srl	a
		srl	a
		srl	a
		ld	b, 0
		ld	c, a
		add	iy, bc		; Add TLA + Akku (Tonadresse)
		ld	d, 0FFh		; Pegelregister laden
LS7:		ld	a, (ix+0)	; Akku mit Wert aus LAA laden
		and	0Fh		; oberes Nibble ausblenden
		ld	c, a
		jr	LS3
PAUDA:		ld	d, 0
		jr	LS7
LS3:		ld	e, (iy+0)	; Tonlngenregister TLR laden
LS2:		xor	a
		ld	b, (iy+0Eh)	; Tonhhenregister laden
		out	(c), d		; Tonausgabe
LS4:		djnz	$
		out	(c), b		; 0-Pegel-Ausgabe
		ld	b, (iy+0Eh)	; Tonhhenregister laden
LS5:		djnz	$
		ld	a, d
		cp	60h		; ca 1/3 Pegel
		jr	z, PEG1
		cp	0
		jr	z, PEG1
		dec	d		; Pegelregister erniedrigen
PEG:		dec	e		; Tonlngenregister erniedrigen
		jr 	nz, LS6
		ld	a, c
		cp	0
		jr	z, LS8
		dec	c
		jr	LS3
LS8:		inc	ix		; LAA erhhen
		jp	INT
LS6:		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jr	LS2
PEG1:		jr	PEG
TLA:		; IY+0 Tonhhen
		db  21h		; 0 = c2	523,2 Hz
		db  23h		; 1 = cis c#
		db  25h		; 2 = d
		db  27h		; 3 = dis d#
		db  29h		; 4 = e
		db  2Ch		; 5 = f
		db  2Eh		; 6 = fis f#
		db  31h		; 7 = g
		db  34h		; 8 = gis g#
		db  37h		; 9 = a
		db  3Ah		; a = ais a#
		db  3Eh		; b = h
		db  41h		; c = c3  c'
		db  49h		; d = d3  d'
		; IY+0Eh Tonlngen
		db  42h		; 0 = 1/16
		db  3Eh		; 1 = 2/16 = 1/8
		db  3Ah		; 2 = 3/16 = 1/8.
		db  37h		; 3 = 4/16 = 1/4
		db  33h		; 4 = 5/16
		db  30h		; 5 = 6/16 = 1/4.
		db  2Dh		; 6 = 7/16
		db  2Ah		; 7 = 8/16 = 1/2
		db  27h		; 8 = 9/16
		db  25h		; 9 = 10/16
		db  22h		; a = 11/16
		db  20h		; b = 12/16 = 1/2.
		db  1Eh		; c = 13/16
		db  1Ch		; d = 14/16

		; Liedtabelle
		; Tne 00..df  4 Bit Ton (0..d) 4 Bit Anz. 16tel (0=1/16, d=16/16)
		; Liedende e0..ef
		; Pause f0..fe
		; Ende Liedfolge ff
		
LAA:		equ	$-1
		db  23h		; "Im Mrzen der Bauer ..."
		db  73h		; d=4: d g g h a a 2c f# f# a g2
		db  73h
		db 0B3h
		db  93h
		db  93h
		db 0C3h
		db  63h
		db  63h
		db  93h
		db  77h
		db 0EEh

		db  41h		; "Im Wald und auf der Heide ..."
		db  43h		; e8 e4 e8 e4 e8 e4. c#4
		db  41h
		db  43h
		db  41h
		db  45h
		db  13h
		db 0EEh

		db  23h		; "Auf, auf zum frhlichen Jagen ..."
		db  75h
		db  21h
		db  73h
		db 0B1h
		db 0B1h
		db  77h
		db  23h
		db  71h
		db 0B1h
		db  93h
		db  23h
		db  23h
		db  71h
		db  61h
		db  77h
		db 0EEh

		db  53h		; "Der Mond ist aufgegangen ..."
		db  73h
		db  53h
		db 0A3h
		db  93h
		db  77h
		db  53h
		db 0EEh

		db    1		; "Horch, was kommt von drauen rein ..."
		db  21h
		db  41h
		db  51h
		db  71h
		db  91h
		db  73h
		db 0EEh

		db  23h		; "Es waren 2 Knigskinder ..."
		db 0B3h
		db 0B1h
		db 0B1h
		db 0B3h
		db  93h
		db  95h
		db  75h
		db 0EEh

		db  93h		; "Sah' ein Knab ..."
		db  91h
		db 0C2h
		db 0A0h
		db  91h
		db  73h
		db  71h
		db  75h
		db 0EEh

		db  75h		; "Auf, du junger Wandersmann ..."
		db  21h
		db  73h
		db  93h
		db 0B3h
		db 0B3h
		db 0B7h
		db 0EEh

		db  25h		; "nnchen von Tharau"
		db  41h
		db  23h
		db  23h
		db  73h
		db  73h
		db  95h
		db 0B1h
		db  93h
		db  77h
		db 0FFh

LAAS:		db  21h		; "Die Gedanken sind frei ..."
		db  21h
		db  73h
		db  73h
		db 0B1h
		db  71h
		db  27h
		db 0FFh

		dephase

;------------------------------------------------------------------------------
; Weihnachtslieder 
;------------------------------------------------------------------------------

		org 200h
		phase 0

DLS0:		di
		ld	ix, DLAA	; Liedanfangsadresse laden
DLS1:		inc	ix		; LAA erhhen
DLANF:		ld	a, (8000h)	; Tastenabfrage
		and	3Fh
		cp	0
		jr	z, DLANF	
		cp	1
		jr	nz, DINT	; Taste 2..6 Liedfolge DLAA
		ld	ix, DLAAS	; Taste 1 - DLAAS (Sind die Lichter...)
DINT:		ld	iy, DTLA
		ld	a, (ix+0)	; Akku mit Wert aus Liedtabelle laden
		cp	0FFh		; Ende der Liedfolge erreicht
		jr	z, DLS0
		and	0F0h
		cp	0E0h		; Ende des Liedes erreicht
		jr	z, DLS1
		cp	0F0h
		jr	z, DPAUDA
		srl	a
		srl	a
		srl	a
		srl	a
		ld	b, 0
		ld	c, a
		add	iy, bc
		ld	d, 0FFh		; Pegelregister laden
DLS7:		ld	a, (ix+0)
		and	0Fh
		ld	c, a
		jr	DLS3
DPAUDA:		ld	d, 0
		jr	DLS7
DLS3:		ld	e, (iy+0)
DLS2:		xor	a
		ld	b, (iy+0Eh)	; Tonhhenregister laden
		out	(c), d
DLS4:		djnz	$
		out	(c), b		; 0-Pegel-Ausgabe
		ld	b, (iy+0Eh)
DLS5:		djnz	$
		ld	a, d
		cp	60h
		jr	z, DPEG1
		cp	0
		jr	z, DPEG1
		dec	d		; Pegelregister erniedrigen
DPEG:		dec	e		; Tonlngenregister erniedrigen
		jr	nz, DLS6
		ld	a, c
		cp	0
		jr	z, DLS8
		dec	c
		jr	DLS3
DLS8:		inc	ix
		jp	DINT
DLS6:		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jr	DLS2
DPEG1:		jr	DPEG
DTLA:		; IY+0 Tonhhen
		db  21h		; 0 = c2	523,2 Hz
		db  23h		; 1 = cis c#
		db  25h		; 2 = d
		db  27h		; 3 = dis d#
		db  29h		; 4 = e
		db  2Ch		; 5 = f
		db  2Eh		; 6 = fis f#
		db  31h		; 7 = g
		db  34h		; 8 = gis g#
		db  37h		; 9 = a
		db  3Ah		; a = ais a#
		db  3Eh		; b = h
		db  41h		; c = c3  c'
		db  49h		; d = d3  d'
		; IY+0Eh Tonlngen
		db  42h		; 0 = 1/16
		db  3Eh		; 1 = 2/16 = 1/8
		db  3Ah		; 2 = 3/16 = 1/8.
		db  37h		; 3 = 4/16 = 1/4
		db  33h		; 4 = 5/16
		db  30h		; 5 = 6/16 = 1/4.
		db  2Dh		; 6 = 7/16
		db  2Ah		; 7 = 8/16 = 1/2
		db  27h		; 8 = 9/16
		db  25h		; 9 = 10/16
		db  22h		; a = 11/16
		db  20h		; b = 12/16 = 1/2.
		db  1Eh		; c = 13/16
		db  1Ch		; d = 14/16

		; Liedtabelle
		; Tne 00..df  4 Bit Ton (0..d) 4 Bit Anz. 16tel (0=1/16, f=16/16)
		; Liedende e0..ef
		; Pause f0..fe
		; Ende Liedfolge ff
		
DLAA:		equ	$-1
		db  95h		; "Alle Jahre wieder ..."
		db 0B1h
		db  93h
		db  73h
		db  67h
		db  47h
		db 0EEh

		db  21h		; "Am Weihnachtsbaume ..."
		db  21h
		db  61h
		db  93h
		db  61h
		db  91h
		db 0D1h
		db 0B1h
		db  93h
		db  61h
		db 0EEh

		db  45h		; "Bald nun ist Weihnachtszeit..."
		db  21h
		db    3
		db  73h
		db  73h
		db  73h
		db  75h
		db  91h
		db  63h
		db  77h
		db 0EEh

		db  41h		; "Guten Abend, schn' Abend..."
		db  41h
		db  93h
		db  83h
		db  63h
		db  43h
		db  93h
		db  13h
		db  43h
		db 0B3h
		db  83h
		db  97h
		db 0EEh

		db  91h		; "Ihr Kinderlein, kommet..."
		db  93h
		db  61h
		db  91h
		db  93h
		db  61h
		db  91h
		db  73h
		db  41h
		db  71h
		db  63h
		db 0EEh

		db  77h		; "Vorfreude, ..."
		db  43h
		db    3
		db  95h
		db  91h
		db  73h
		db  43h
		db 0EEh

		db  73h		; "Morgen, Kinder, ..."
		db  23h
		db  43h
		db  23h
		db  41h
		db  71h
		db  61h
		db  91h
		db  73h
		db  23h
		db 0EEh

		db  93h		; "Lat uns froh und munter sein"
		db  93h
		db  91h
		db  81h
		db  91h
		db  71h
		db  63h
		db  63h
		db  63h
		db 0EEh

		db  97h		; "Oh, du frhlich ..."
		db  0B7h
		db  95h
		db  71h
		db  63h
		db  73h
		db 0FFh

DLAAS:		db  63h		; "Sind die Lichter angezndet ..."
		db  71h
		db  93h
		db  91h
		db  73h
		db  61h
		db  43h
		db  41h
		db 0FFh
		
		dephase

;------------------------------------------------------------------------------
; Amateurfunksignale
;------------------------------------------------------------------------------

		org 300h
		phase 0
		
RLS0:		di
RLANF:		ld	a, (8000h)	; Tastenabfrage
		and	3Fh
		cp	0
		jr	z, RLANF
		cp	20h
		jr	nz, NEXT1
		ld	ix, RLAA1	; Taste 6 - RLAA1 (SOS)
		jr	RLS1
NEXT1:		cp	10h
		jr	nz, NEXT2
		ld	ix, RLAA2	; Taste 5 - RLAA2 (CQ)
		jr	RLS1
NEXT2:		cp	8
		jr	nz, NEXT3
		ld	ix, RLAA3	; Taste 4 - RLAA3 (99)
		jr	RLS1
NEXT3:		cp	4
		jr	nz, NEXT4
		ld	ix, RLAA4	; Taste 3 - RLAA4 (88)
		jr	RLS1
NEXT4:		cp	2
		jr	nz, NEXT5
		ld	ix, RLAA5	; Taste 2 - RLAA5 ()
		jr	RLS1
NEXT5:		ld	ix, RLAA6	; Taste 1 - RLAA6 ()
RLS1:		inc	ix		; LAA erhhen
RINT:		ld	iy, RTLA
		ld	a, (ix+0)	; Akku mit Wert aus Rufzeichentabelle
		cp	0FFh		; Ende der Rufzeichenfolge erreicht
		jr	z, RLS0
		and	0F0h
		cp	0E0h		; Ende eines Rufzeichens erreicht
		jr	z, RLS1
		cp	0F0h
		jr	z, RPAUDA
		;Ton		
		srl	a		; Akku 4x rechts schieben
		srl	a		; (vp: wozu ???)
		srl	a
		srl	a
		ld	d, 0FFh		; Pegelregister laden
RLS7:		ld	a, (ix+0)	; Akku mit Wert aus LAA laden
		and	0Fh		; oberes Nibble ausblenden
		ld	c, a
		jr	RLS3
RPAUDA:		ld	d, 0
		jr	RLS7
		; Ton
RLS3:		ld	e, (iy+0)	; Tonlngenregister TLR laden
RLS2:		xor	a
		ld	b, (iy+1)	; Tonhhenregister laden
		out	(c), d		; Pegelregisterausgabe
RLS4:		djnz	$
		out	(c), b		; 0-Pegel-Ausgabe
		ld	b, (iy+1)	; Tonhhenregister laden
RLS5:		djnz	$
RPEG:		dec	e		; Tonlngenregister erniedrigen
		jr	nz, RLS6
		ld	a, c
		cp	0
		jr	z, RLS9
		dec	c
		jr	RLS3
RLS9:		ld	a, d
		cp	0
		jr	z, RLS8
		; 1/16 Pause nach Ton
		ld	d, 0		; Pegel 0
		ld	c, 0		; 1/16 Pause
		jr	RLS3
RLS8:		inc	ix		; LAA erhhen
		jp	RINT
RLS6:		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jr	RLS2
		jr	RPEG

RTLA:		; IY+0 Tonlnge
		db  49h		; 1/16
		;db 25h		; 1/32 alternativ
		; IY+1 Tonhhe
		db  1Ch		; 

		; Rufzeichentabelle
		; Tne x0 Punkt, x1 Strich, x = 0..e
		; Pause f0..fe
		; Ende ff

RLAA1:		equ	$-1
		db    0		; "SOS"
		db    0
		db    0
		db 0F0h
		db    1
		db    1
		db    1
		db 0F0h
		db    0
		db    0
		db    0
		db 0F4h
		db 0FFh

RLAA2:		equ	$-1
		db    1		; "CQ" - allgemeiner Anruf
		db    0
		db    1
		db    0
		db 0F0h
		db    1
		db    1
		db    0
		db    1
		db 0F4h
		db 0FFh

RLAA3:		equ	$-1
		db    1		; "99" - Rume den Kanal!
		db    1
		db    1
		db    1
		db    0
		db 0F0h
		db    1
		db    1
		db    1
		db    1
		db    0
		db 0F4h
		db 0FFh

RLAA4:		equ	$-1
		db    1		; "88" - Liebe und Ksse
		db    1
		db    1
		db    0
		db    0
		db 0F0h
		db    1
		db    1
		db    1
		db    0
		db    0
		db 0F4h
		db 0FFh

RLAA5:		equ	$-1
		db 0FFh

RLAA6:		equ	$-1
		db 0FFh
		dephase

		end
